//
//  MyViewController.m
//  test
//
//  Created by Macx on 16/7/23.
//  Copyright © 2016年 LLG. All rights reserved.
//
#define WS(ws) __weak typeof(self) ws = self

#define SS(ss) __strong typeof(self)ss = self
#import "MyViewController.h"

#import "ColltionTableViewCell.h"
#import "JsonModle.h"

@interface MyViewController ()<UITableViewDelegate,UITableViewDataSource,UICollectionViewDataSource,UICollectionViewDelegate>
@property (nonatomic,strong)UITableView *mytableView;
@end

@implementation MyViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    [self.view addSubview:self.mytableView];
    _mytableView.delegate = self;
    _mytableView.dataSource = self;
    [_mytableView registerClass:[ColltionTableViewCell class] forCellReuseIdentifier:@"tableViewCell"];
   NSString *filePath = [[NSBundle mainBundle]pathForResource:@"jsonData" ofType:@"json"];
    
    NSData *jsonData = [NSData dataWithContentsOfFile:filePath];
    NSError *error = nil;
   id  jsonMessage = [NSJSONSerialization JSONObjectWithData:jsonData options:NSJSONReadingMutableContainers error:&error];
    if (error)
    {
          NSLog(@"-----data转化json数据错误------%@",error);
        return;
    }

    if ([jsonMessage isKindOfClass:[NSDictionary class]])
    {
            NSLog(@"%@",[jsonMessage class]);
        
        if ([jsonMessage[@"success"] isEqual:@1])
        {
             NSLog(@"------请求成功");
            
              JsonModle *jsonModle = [[JsonModle alloc]initWithObject:jsonMessage];
            [self.imageArrayS addObjectsFromArray:jsonModle.dynamicListArry];
         }
    }
    else
    {
        NSLog(@"居然不是字典类型的 ===%@",[jsonMessage class]);
    }
   
}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return self.imageArrayS.count;
}
-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *identifier = @"tableViewCell";
    StyleModle *styleModle = self.imageArrayS[indexPath.row];
    ColltionTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:identifier forIndexPath:indexPath];
    cell.colletionView.tag = indexPath.row+1000;
    cell.colletionView.delegate = self;
    cell.colletionView.dataSource = self;
    [cell.colletionView reloadData];
    cell.styleModle = styleModle;
    if (cell.hasLongPress)
    {
        //防止来回调用删除的方法的时候调用不存在的对象而造成的崩溃
        //长按是会调用多次的 所以用一个BOOL值来限制
        cell.hasLongPress = NO;
    }
    WS(ws);
    [cell setDidlongPress:^(ColltionTableViewCell *acell) {
        [ws showAlerView:@"您确定要删除？" compods:^(NSString *title) {
            if ([title isEqualToString:@"确定"])
            {
                [ws.imageArrayS removeObjectAtIndex:acell.colletionView.tag-1000];
                
                [ws.mytableView reloadData];
            }else{
                acell.hasLongPress = NO;
            }
        }];
    }];
    return cell;
}
-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    StyleModle *styleModle = self.imageArrayS[indexPath.row];
    NSArray *array =styleModle.imagesArray;
    //根据
    NSInteger number = array.count%3;
    CGFloat aheight = 0;
    
    if (number>0&&number<3)
    {
        aheight = 80;
    }
    CGFloat height = array.count/3*80 +aheight+styleModle.contentHeight;
    
    return height;
}
#pragma mark 懒加载
-(UITableView *)mytableView
{
    if (_mytableView)
    {
        return _mytableView;
    }
    _mytableView = [[UITableView alloc]initWithFrame:self.view.bounds style:UITableViewStyleGrouped];
    return _mytableView;
}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
